/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of MMV.xs. Do not edit this file, edit MMV.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "MMV.xs"
/*
 * Copyright (c) 2009 Aconex.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#include "pmapi.h"
#include "mmv_stats.h"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

static int
list_to_metric(SV *list, mmv_metric_t *metric)
{
    int		i, len;
    SV		**entry[8];
    AV		*mlist = (AV *) SvRV(list);

    if (SvTYPE((SV *)mlist) != SVt_PVAV) {
	warn("metric declaration is not an array reference");
	return -1;
    }
    len = av_len(mlist) + 1;
    if (len < 6) {
	warn("too few entries in metric array reference");
	return -1;
    }
    if (len > 8) {
	warn("too many entries in metric array reference");
	return -1;
    }
    for (i = 0; i < len; i++)
	entry[i] = av_fetch(mlist, i, 0);

    strncpy(metric->name, SvPV_nolen(*entry[0]), MMV_NAMEMAX);
    metric->name[MMV_NAMEMAX-1] = '\0';
    metric->item = SvIV(*entry[1]);
    metric->type = SvIV(*entry[2]);
    metric->indom = SvIV(*entry[3]);
    i = SvIV(*entry[4]);
    memcpy(&metric->dimension, &i, sizeof(pmUnits));
    metric->semantics = SvIV(*entry[5]);
    if (len > 6)
	metric->shorttext = strdup(SvPV_nolen(*entry[6]));
    else
	metric->shorttext = NULL;
    if (len > 7)
	metric->helptext = strdup(SvPV_nolen(*entry[7]));
    else
	metric->helptext = NULL;
    return 0;
}

static int
list_to_instances(SV *list, mmv_instances_t **insts)
{
    mmv_instances_t	*instances;
    int			i, len;
    AV			*inlist = (AV *) SvRV(list);

    if (SvTYPE((SV *)inlist) != SVt_PVAV) {
	warn("instances declaration is not an array reference");
	return -1;
    }
    len = av_len(inlist) + 1;
    if (len++ % 2) {
	warn("odd number of entries in instance array reference");
	return -1;
    }

    len /= 2;
    instances = (mmv_instances_t *)calloc(len, sizeof(mmv_instances_t));
    if (instances == NULL) {
	warn("insufficient memory for instance array");
	return -1;
    }
    for (i = 0; i < len; i++) {
	SV **id = av_fetch(inlist, i*2, 0);
	SV **name = av_fetch(inlist, i*2+1, 0);
	instances[i].internal = SvIV(*id);
	strncpy(instances[i].external, SvPV_nolen(*name), MMV_NAMEMAX);
	instances[i].external[MMV_NAMEMAX-1] = '\0';
    }
    *insts = instances;
    return len;
}

static int
list_to_indom(SV *list, mmv_indom_t *indom)
{
    int		i, len;
    SV		**entry[4];
    AV		*ilist = (AV *) SvRV(list);

    if (SvTYPE((SV *)ilist) != SVt_PVAV) {
	warn("indom declaration is not an array reference");
	return -1;
    }
    len = av_len(ilist) + 1;
    if (len < 2) {
	warn("too few entries in indom array reference");
	return -1;
    }
    if (len > 4) {
	warn("too many entries in indom array reference");
	return -1;
    }
    for (i = 0; i < len; i++)
	entry[i] = av_fetch(ilist, i, 0);

    indom->serial = SvIV(*entry[0]);
    if ((i = list_to_instances(*entry[1], &indom->instances)) < 0)
	return -1;
    indom->count = i;
    if (len > 2)
	indom->shorttext = strdup(SvPV_nolen(*entry[2]));
    else
	indom->shorttext = NULL;
    if (len > 3)
	indom->helptext = strdup(SvPV_nolen(*entry[3]));
    else
	indom->helptext = NULL;
    return 0;
}

static int
list_to_metrics(SV *list, mmv_metric_t **metriclist, int *mcount)
{
    mmv_metric_t	*metrics;
    int			i, len;
    AV			*mlist = (AV *) SvRV(list);

    if (SvTYPE((SV *)mlist) != SVt_PVAV) {
	warn("metrics list is not an array reference");
	return -1;
    }
    len = av_len(mlist) + 1;
    metrics = (mmv_metric_t *)calloc(len, sizeof(mmv_metric_t));
    if (metrics == NULL) {
	warn("insufficient memory for metrics array");
	return -1;
    }
    for (i = 0; i < len; i++) {
	SV **entry = av_fetch(mlist, i, 0);
	if (list_to_metric(*entry, &metrics[i]) < 0)
	    break;
    }
    *metriclist = metrics;
    *mcount = len;
    return (i == len);
}

static int
list_to_indoms(SV *list, mmv_indom_t **indomlist, int *icount)
{
    mmv_indom_t		*indoms;
    int			i, len;
    AV			*ilist = (AV *) SvRV(list);

    if (SvTYPE((SV *)ilist) != SVt_PVAV) {
	warn("indoms list is not an array reference");
	return -1;
    }
    len = av_len(ilist) + 1;
    indoms = (mmv_indom_t *)calloc(len, sizeof(mmv_indom_t));
    if (indoms == NULL) {
	warn("insufficient memory for indoms array");
	return -1;
    }
    for (i = 0; i < len; i++) {
	SV **entry = av_fetch(ilist, i, 0);
	if (list_to_indom(*entry, &indoms[i]) < 0)
	    break;
    }
    *indomlist = indoms;
    *icount = len;
    return (i == len);
}


#line 200 "MMV.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 252 "MMV.c"

XS(XS_PCP__MMV_mmv_stats_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "name, cl, fl, metrics, indoms");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	cl = (int)SvIV(ST(1));
	int	fl = (int)SvIV(ST(2));
	SV *	metrics = ST(3);
	SV *	indoms = ST(4);
#line 200 "MMV.xs"
	int			i, j;
	int			mcount;
	int			icount;
	mmv_metric_t *		mlist;
	mmv_indom_t *		ilist;
#line 276 "MMV.c"
	void *	RETVAL;
	dXSTARG;
#line 206 "MMV.xs"
	i = list_to_metrics(metrics, &mlist, &mcount);
	j = list_to_indoms(indoms, &ilist, &icount);

	if (i <= 0 || j <= 0) {
	    warn("mmv_stats_init: bad list conversion: metrics=%d indoms=%d\n", i, j);
	    RETVAL = NULL;
	}
	else {
	    RETVAL = mmv_stats_init(name, cl, fl, mlist, mcount, ilist, icount);
	    if (RETVAL == NULL)
		warn("mmv_stats_init failed: %s\n", osstrerror());
	}

	for (i = 0; i < icount; i++) {
	    if (ilist[i].shorttext)
		free(ilist[i].shorttext);
	    if (ilist[i].helptext)
		free(ilist[i].helptext);
	    free(ilist[i].instances);
	}
	if (ilist)
	    free(ilist);
	for (i = 0; i < mcount; i++) {
	    if (mlist[i].shorttext)
		free(mlist[i].shorttext);
	    if (mlist[i].helptext)
		free(mlist[i].helptext);
	}
	if (mlist)
	    free(mlist);

	if (!RETVAL)
	    XSRETURN_UNDEF;
#line 313 "MMV.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_PCP__MMV_mmv_stats_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "handle, name");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
#line 247 "MMV.xs"
	mmv_stats_stop(handle, name);
#line 335 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_units); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_units)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "dim_space, dim_time, dim_count, scale_space, scale_time, scale_count");
    {
	unsigned int	dim_space = (unsigned int)SvUV(ST(0));
	unsigned int	dim_time = (unsigned int)SvUV(ST(1));
	unsigned int	dim_count = (unsigned int)SvUV(ST(2));
	unsigned int	scale_space = (unsigned int)SvUV(ST(3));
	unsigned int	scale_time = (unsigned int)SvUV(ST(4));
	unsigned int	scale_count = (unsigned int)SvUV(ST(5));
#line 258 "MMV.xs"
	pmUnits			units;
#line 360 "MMV.c"
	int	RETVAL;
	dXSTARG;
#line 260 "MMV.xs"
	units.pad = 0;
	units.dimSpace = dim_space;	units.scaleSpace = scale_space;
	units.dimTime = dim_time;	units.scaleTime = scale_time;
	units.dimCount = dim_count;	units.scaleCount = scale_count;
	RETVAL = *(int *)(&units);
#line 369 "MMV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_PCP__MMV_mmv_lookup_value_desc); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_lookup_value_desc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, metric, instance");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	pmAtomValue *	RETVAL;
#line 274 "MMV.xs"
	RETVAL = mmv_lookup_value_desc(handle, metric, instance);
#line 393 "MMV.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "pmAtomValuePtr", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_PCP__MMV_mmv_inc_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_inc_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, atom, value");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	pmAtomValue *	atom;
	double	value = (double)SvNV(ST(2));

	if (sv_derived_from(ST(1), "pmAtomValuePtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    atom = INT2PTR(pmAtomValue *,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"PCP::MMV::mmv_inc_value",
			"atom", "pmAtomValuePtr");
#line 284 "MMV.xs"
	mmv_inc_value(handle, atom, value);
#line 426 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_set_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_set_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, atom, value");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	pmAtomValue *	atom;
	double	value = (double)SvNV(ST(2));

	if (sv_derived_from(ST(1), "pmAtomValuePtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    atom = INT2PTR(pmAtomValue *,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"PCP::MMV::mmv_set_value",
			"atom", "pmAtomValuePtr");
#line 292 "MMV.xs"
	mmv_set_value(handle, atom, value);
#line 457 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_set_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_set_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, atom, string");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	pmAtomValue *	atom;
	SV *	string = ST(2);
#line 300 "MMV.xs"
	int			length;
	char *			data;
#line 480 "MMV.c"

	if (sv_derived_from(ST(1), "pmAtomValuePtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    atom = INT2PTR(pmAtomValue *,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"PCP::MMV::mmv_set_string",
			"atom", "pmAtomValuePtr");
#line 303 "MMV.xs"
	data = SvPV_nolen(string);
	length = strlen(data);
	mmv_set_string(handle, atom, data, length);
#line 494 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, metric, instance, count");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	double	count = (double)SvNV(ST(3));
#line 314 "MMV.xs"
	mmv_stats_add(handle, metric, instance, count);
#line 517 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_inc); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_inc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "handle, metric, instance");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
#line 322 "MMV.xs"
	mmv_stats_inc(handle, metric, instance);
#line 539 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, metric, instance, value");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	double	value = (double)SvNV(ST(3));
#line 331 "MMV.xs"
	mmv_stats_set(handle, metric, instance, value);
#line 562 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_add_fallback); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_add_fallback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "handle, metric, instance, instance2, count");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	char *	instance2 = (char *)SvPV_nolen(ST(3));
	double	count = (double)SvNV(ST(4));
#line 341 "MMV.xs"
	mmv_stats_add_fallback(handle, metric, instance, instance2, count);
#line 586 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_inc_fallback); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_inc_fallback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, metric, instance, instance2");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	char *	instance2 = (char *)SvPV_nolen(ST(3));
#line 350 "MMV.xs"
	mmv_stats_inc_fallback(handle, metric, instance, instance2);
#line 609 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_interval_start); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_interval_start)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, value, metric, instance");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	pmAtomValue *	value;
	char *	metric = (char *)SvPV_nolen(ST(2));
	char *	instance = (char *)SvPV_nolen(ST(3));

	if (sv_derived_from(ST(1), "pmAtomValuePtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    value = INT2PTR(pmAtomValue *,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"PCP::MMV::mmv_stats_interval_start",
			"value", "pmAtomValuePtr");
#line 359 "MMV.xs"
	mmv_stats_interval_start(handle, value, metric, instance);
#line 641 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_interval_end); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_interval_end)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "handle, value");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	pmAtomValue *	value;

	if (sv_derived_from(ST(1), "pmAtomValuePtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    value = INT2PTR(pmAtomValue *,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"PCP::MMV::mmv_stats_interval_end",
			"value", "pmAtomValuePtr");
#line 366 "MMV.xs"
	mmv_stats_interval_end(handle, value);
#line 671 "MMV.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_PCP__MMV_mmv_stats_set_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__MMV_mmv_stats_set_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "handle, metric, instance, string");
    {
	void *	handle = INT2PTR(void *,SvIV(ST(0)));
	char *	metric = (char *)SvPV_nolen(ST(1));
	char *	instance = (char *)SvPV_nolen(ST(2));
	SV *	string = ST(3);
#line 375 "MMV.xs"
	int			length;
	char *			data;
#line 695 "MMV.c"
#line 378 "MMV.xs"
	data = SvPV_nolen(string);
	length = strlen(data);
	mmv_stats_set_strlen(handle, metric, instance, data, length);
#line 700 "MMV.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PCP__MMV); /* prototype to pass -Wmissing-prototypes */
XS(boot_PCP__MMV)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("PCP::MMV::mmv_stats_init", XS_PCP__MMV_mmv_stats_init, file);
        newXS("PCP::MMV::mmv_stats_stop", XS_PCP__MMV_mmv_stats_stop, file);
        newXS("PCP::MMV::mmv_units", XS_PCP__MMV_mmv_units, file);
        newXS("PCP::MMV::mmv_lookup_value_desc", XS_PCP__MMV_mmv_lookup_value_desc, file);
        newXS("PCP::MMV::mmv_inc_value", XS_PCP__MMV_mmv_inc_value, file);
        newXS("PCP::MMV::mmv_set_value", XS_PCP__MMV_mmv_set_value, file);
        newXS("PCP::MMV::mmv_set_string", XS_PCP__MMV_mmv_set_string, file);
        newXS("PCP::MMV::mmv_stats_add", XS_PCP__MMV_mmv_stats_add, file);
        newXS("PCP::MMV::mmv_stats_inc", XS_PCP__MMV_mmv_stats_inc, file);
        newXS("PCP::MMV::mmv_stats_set", XS_PCP__MMV_mmv_stats_set, file);
        newXS("PCP::MMV::mmv_stats_add_fallback", XS_PCP__MMV_mmv_stats_add_fallback, file);
        newXS("PCP::MMV::mmv_stats_inc_fallback", XS_PCP__MMV_mmv_stats_inc_fallback, file);
        newXS("PCP::MMV::mmv_stats_interval_start", XS_PCP__MMV_mmv_stats_interval_start, file);
        newXS("PCP::MMV::mmv_stats_interval_end", XS_PCP__MMV_mmv_stats_interval_end, file);
        newXS("PCP::MMV::mmv_stats_set_string", XS_PCP__MMV_mmv_stats_set_string, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

